
/*
 * Remote data logger and game camera with photo transmittion
 * using a Verison Samsung Gusto 2 prepaid cell phone
 * interfaced to an Arduino Mega
 * LVEZ1 Sonar sensor to measure liquid level
 */

int analogPin = 3;                       // Ultrasound signal pin
int val = 0;                             // a working variable
float dist = 0;                          // distance in inches. 10mv/inch.
float const1 = 0.5005;                   // (5/1023)volts * (512/5)inch/volt = 0.5005
int shortpress = 250;                    // a short press in milliseconds
int butdel = 3000;                       // normal delay after button press
int incomingByte = 0;                    // for incoming serial data
String str1;                             // text message string
String str2;                             // will hold number
char str3[30];                           // character array

unsigned long previousMillis = 0;        // will store last time picture taken
unsigned long interval = 86400000;       // interval between pictures. 24 hr.
unsigned long currentMillis;             // current millisecond reading

void setup() 
{
  pinMode(22, OUTPUT);                   // A button press pin
  pinMode(24, OUTPUT);                   // A button press pin
  pinMode(26, OUTPUT);                   // A button press pin
  pinMode(28, OUTPUT);                   // A button press pin
  pinMode(30, OUTPUT);                   // A button press pin
  pinMode(32, OUTPUT);                   // A button press pin
  pinMode(34, OUTPUT);                   // A button press pin
  pinMode(36, OUTPUT);                   // A button press pin
  pinMode(38, OUTPUT);                   // A button press pin
  pinMode(40, OUTPUT);                   // A button press pin
  pinMode(42, OUTPUT);                   // A button press pin
  pinMode(44, OUTPUT);                   // A button press pin
  pinMode(46, OUTPUT);                   // A button press pin
  pinMode(48, OUTPUT);                   // A button press pin

  Serial.begin(9600);
}

void loop()
{
  // send a photo every 24 hours with the following block of code
  currentMillis = millis();
  if(currentMillis - previousMillis > interval)  // it is time to take photo
  {
    previousMillis = currentMillis;      // reset time
    val = analogRead(analogPin);         // read the input pin
    dist = val * const1;                 // Distance in inches
    str1 = "water level, inches = ";
    str2 = String(int(dist), DEC);       // store interger value into string str2
    str1 = str1 + str2;                  // append measured distance from ping sensor to string
    str1 = str1 + ".";                   // add a decimal point. didn't work right str1+str2+"."?
    dist = dist - int(dist);             // Leave the remainder / fractional part of dist
    dist = dist * 10;                    // move the first fractional digit left of decimal point
    str2 = String(int(dist), DEC);       // store first fractional digit into sring str2
    str1 = str1 + str2 + ".";            // append first fractional digit to string
    for (int y = 0; y < str1.length(); y=y+1)
    {
      str3[y] = str1.charAt(y);          // transpose String str1 to Char str3
      str3[y+1] = '\0';                  // will get overwritten except on last loop.   
    } 
    picture();                           // take and send the picture with text message
  }

  // forward key stroke from serial monitor if there are any
  // this is a handy troubleshooting utility during the build
  // also report reading from distance sensor on little "d". 
  if (Serial.available() > 0) 
  {
    incomingByte = Serial.read();
    Serial.print("I received: ");
    Serial.println(incomingByte, DEC);
    if(incomingByte == 101)              // it's a little 'e'. hold button longer
    {
      Serial.println("Sending a long E press");
      pushbutton('E', 3000);             // to turn on or off phone.
    }
    else
    {
      pushbutton(incomingByte, shortpress);// press & hold end button to turn on phone
    }
  }
}


void picture()
{
  Serial.println('Inside picture subroutine. ');      

  pushbutton('E', 3000);                // press & hold end button to turn on phone
  delay(30000);                         // then wait 30 seconds.

  pushbutton('E', shortpress);          // press end to make sure ready state
  delay(butdel);
  pushbutton('E', shortpress);          // end button again to make sure at ready state
  delay(butdel);
  pushbutton('E', shortpress);          // end button again to make sure at ready state
  delay(butdel);
  pushbutton('E', shortpress);          // end button again to make sure at ready state
  delay(butdel);                        // a lot of ends helps prevent problems.
  pushbutton('P', shortpress);          // camera button to start camera function
  delay(butdel);
  pushbutton('E', shortpress);          // Aport camera function to clear 1 time message
  delay(butdel);
  pushbutton('P', shortpress);          // camera button to start camera function again
  delay(butdel);
  pushbutton('O', shortpress);          // OK button to take photo
  delay(butdel);
  pushbutton('O', shortpress);          // OK again to sent photo
  delay(butdel);
  pushbutton('4', shortpress);          // This button enters a 'G' and pops up my 
  delay(butdel);                        // Gmail account entered earlier
  pushbutton('D', shortpress);          // Down to highlight the Gmail account
  delay(butdel);
  pushbutton('O', shortpress);          // OK to select the Gmail account
  delay(butdel);
  pushbutton('O', shortpress);          // OK again to create message
  delay(butdel);                        
  entertext(str3);                      // enter text string on phone
  pushbutton('O', shortpress);          // OK again to sent
  
  delay(60000);                         // wait 1 minutes for send
  pushbutton('E', 3000);                // press & hold end button to turn off phone
  delay(60000);                         // wait 1 minutes after send
}

void pushbutton(char button, int PRESSTIME)
{

 /* 
 * What pins need to be on to simulate a button press.
 * It takes to pins to press one button.
 * Code uses pins 22,24,26,28,30,32,34,36,38,40,42,44,46,48 as output
 * 
 *     Button      Button Code     Pin 1     Pin 2
 * -----------------------------------------------
 * 0   Left Soft        <           22        24
 * 1   Right Soft       >           26        24
 * 2   Up               U           28        30
 * 3   Down             D           28        32
 * 4   Right            R           28        34
 * 5   Left             L           28        36
 * 6   OK               O           28        24
 * 7   Send             S           22        36
 * 8   CLR              C           26        36
 * 9   End              E           38        40
 * 10  1                1           22        34
 * 11  2                2           42        34
 * 12  3                3           26        34
 * 13  4                4           22        32
 * 14  5                5           42        32
 * 15  6                6           26        32
 * 16  7                7           22        30
 * 17  8                8           42        30
 * 18  9                9           26        30
 * 19  *                *           22        44
 * 20  0                0           42        44
 * 21  #                #           26        44
 * 22  ICE              I           42        24
 * 23  Messaging        M           28        44
 * 24  Camera           P           46        48
 * 25  Voicel Mail      V           42        36
 */
 
 char buttons[27] = "<>UDRLOSCE123456789*0#IMPV";  // one extra for the null
 int pin1[26] = {22,26,28,28,28,28,28,22,26,38,22,42,26,22,42,26,22,42,26,22,42,26,42,28,46,42};
 int pin2[26] = {24,24,30,32,34,36,24,36,36,40,34,34,34,32,32,32,30,30,30,44,44,44,24,44,48,36};
 int pointer;

 Serial.println("In pushbutton routine");

 pointer = -1;                          // make sure there is a valid button
 for (int i = 0; i<26; i=i+1)           // compare with each element in the list
 {
  if (button == buttons[i]) pointer = i;// set pointer to i if there is a match.
 }

 if (pointer != -1)                     // there is a match. push the button.
 {
  Serial.print("Pointer = ");
  Serial.println(pointer, DEC);
  Serial.print("Pin 1 = ");
  Serial.println(pin1[pointer], DEC);
  Serial.print("Pin 2 = ");
  Serial.println(pin2[pointer], DEC);
  
  digitalWrite(pin1[pointer], HIGH);    // close the reed switch
  digitalWrite(pin2[pointer], HIGH);    // close the reed switch
  delay(PRESSTIME);                     // waits for defined time in milliseconds
  digitalWrite(pin1[pointer], LOW);     // opens the reed switch 
  digitalWrite(pin2[pointer], LOW);     // opens the reed switch
 }
}

void entertext(char str1[])
{
 /*
  * This routine disects and input string into a series of characters
  * It then types these characters to the phone by pressing the 
  * appropriate button the appropriate number of times. 
  * For example, you have to hit the phone button #2 two times to get a "b".  
  *
  *              Text           ASCII        Button        Presses
  * --------------------------------------------------------------
  * 0              .             46             1             1
  * 1              @             64             1             2
  * 2              ?             33             1             3
  * 3              !             33             1             4
  * 4              -             45             1             5
  * 5              ,             44             1             6
  * 6              &             38             1             7
  * 7              :             58             1             8
  * 8              '             39             1             9
  * 9              /             47             1             10
  * 10             1             49             1             11
  * 11             a             65             2             1
  * 12             b             66             2             2
  * 13             c             67             2             3
  * 14             2             50             2             4
  * 15             d             68             3             1
  * 16             e             69             3             2
  * 17             f             70             3             3
  * 18             3             51             3             4
  * 19             g             71             4             1
  * 20             h             72             4             2
  * 21             i             73             4             3
  * 22             4             52             4             4
  * 23             j             74             5             1
  * 24             k             75             5             2
  * 25             l             76             5             3
  * 26             5             53             5             4
  * 27             m             77             6             1
  * 28             n             78             6             2
  * 29             o             79             6             3
  * 30             6             54             6             4
  * 31             p             80             7             1
  * 32             q             81             7             2
  * 33             r             82             7             3
  * 34             s             83             7             4
  * 35             7             55             7             5
  * 36             t             84             8             1
  * 37             u             85             8             2
  * 38             v             86             8             3
  * 39             8             56             8             4
  * 40             w             87             9             1
  * 41             x             88             9             2
  * 42             y             89             9             3
  * 43             z             90             9             4
  * 44             9             57             9             5
  * 45             0             48             0             1
  * 46           Space           32             #             1
  */
  
  // the following arrays contain the information from the above table
  char characters[48] = ".@?!-,&:'/1abc2def3ghi4jkl5mno6pqrs7tuv8wxyz90 ";
  char button[48] = "1111111111122223333444455556666777778888999990#"; 
  int presses[47] = {1,2,3,4,5,6,7,8,9,10,11,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,1,2,3,4,5,1,2,3,4,1,2,3,4,5,1,1};

  int pointer1;
  int i;
  int n;

  Serial.println("inside entertext routine");
  
  i = 0;
  while (str1[i] != '\0')
  {
    Serial.print("i = ");
    Serial.println(i, DEC);
    pointer1 = -1;                                 // make sure it is a valid character
    for (n = 0; n<47; n=n+1)                       // compare with each element in the array
    {
      if (characters[n] == str1[i]) pointer1 = n;  // set pointer to n if there is a match.
    }
    Serial.print("Pointer1 = ");
    Serial.println(pointer1, DEC);
    if (pointer1 != -1)                            // there is a match. push the button.
    { 
      for (n = 1; n <= presses[pointer1]; n=n+1)   // press the button this many times
      {
        pushbutton(char(button[pointer1]), 100);   // press the button quickly
        delay(100);
      }
    }
    i=i+1;                                         // increment i in while loop.
  }
} 
  
